import sys
import os

sys.path.append("/usr/share/maildisclaimer")
from bitbone.config import MDConfigReader

class classproperty(object):
    def __init__(self, f):
        self.f = f

    def __get__(self, obj, owner):
        return self.f(owner)

class MaildisclaimerSyntax(select):

    @classproperty
    def choices(self):

        config = MDConfigReader()
        config.read("/etc/maildisclaimer/server.cfg")
        template_path = config['disclaimer_dir']+"/templates"

        files = os.listdir(template_path)
        files = filter( lambda x: not os.path.islink("%s/%s" % (template_path, x)) and not os.path.isdir("%s/%s" % (template_path, x)), files )
        files = map( lambda x: x.rsplit(".", 1)[0], files )
        files = list(set(files))
        files.sort()

        files.insert(0, "")

        return map( lambda x: (x, x), files)

